Bug 126991

Summary: Text with simple line layout not getting pushed below float when there is not enough space for it
Product: WebKit Reporter: Ralph T <ralpht+bugs>
Component: Layout and RenderingAssignee: Nobody <webkit-unassigned>
Status: RESOLVED FIXED    
Severity: Normal CC: commit-queue, esprehn+autocc, glenn, koivisto, kondapallykalyan, mmaxfield, ralpht+bugs, zalan
Priority: P2 Keywords: InRadar
Version: 528+ (Nightly build)   
Hardware: Unspecified   
OS: Unspecified   
URL: http://www.theverge.com/2014/1/2/5264580/the-lost-secrets-of-webos
Attachments:
Description Flags
Screenshot of bad overlapping layout
none
reduced test case
none
patch kling: review+

Description Ralph T 2014-01-14 10:26:34 PST
This page uses an unaccelerated CSS animation (of width, with height set to auto) to grow "float: right" (class "zm right zoom") boxes containing images on hover.

If you scroll to "SAPPHIRE" and hover the image on the right then at the end of the animation the text overlaps the image. With simple line layout disabled the text does not overlap the image.
Comment 1 Ralph T 2014-01-14 10:31:57 PST
Created attachment 221177 [details]
Screenshot of bad overlapping layout

I see this with a build I made using r161903 from yesterday on an elderly macbook air.
Comment 2 Ralph T 2014-01-20 17:16:20 PST
I thought this might have been fixed after Zalan's change r162340, but it still persists. Layout is fine with SimpleLineLayout disabled (I just change canUse() to always return false), so I'm pretty sure this is a SimpleLineLayout bug.
Comment 3 zalan 2014-01-20 20:47:42 PST
Created attachment 221718 [details]
reduced test case

This is definitely a layout issue and not paint coordinates snapping (what my patch addressed)
Comment 4 Antti Koivisto 2014-01-21 07:19:41 PST
SimpeLineLayout::canUseFor had code to disable the path for constrained float cases like this. I suspect the cached canUseFor is just not cleared after dynamic style change here. Or the existing test is just insufficient.
Comment 5 Antti Koivisto 2014-05-11 01:51:19 PDT
Created attachment 231258 [details]
patch
Comment 6 Antti Koivisto 2014-05-11 01:51:39 PDT
<rdar://problem/16843257>
Comment 7 Antti Koivisto 2014-05-11 02:43:35 PDT
https://trac.webkit.org/r168598